package tdspp.Clock;

import tdspp.util.*;
import Prism.core.*;
import java.util.*;
import java.io.*;


public class Clock extends AbstractImplementation implements Runnable  {
	protected int deltaMilli;
	protected Thread t; 

	/**
	 * Default constructor
	 */
	public Clock() {
		this("Clock");
	}

	public Clock (String comp_name) {
		
		deltaMilli = Constants.CLOCK_DELAY;
	}

	public void start() {
		super.start();
		t = new Thread(this);
		t.start();
	}

	public void run() {
		while (true) {
			Event n = new Event(tdspp.util.MessageConstants.MESSAGE_NAME_TICK );
			n.eventType=PrismConstants.REPLY;
			send(n);
			try {
				t.sleep(deltaMilli);
			} 
			catch (Exception e) {
				System.err.println("Exception: " + e.getMessage());
			}
		}
	}
	public void handle(Event e){}
	}
